#pragma once

#include "core/sprite.h"
#include "core/color.h"
#include "core/rectangle.h"

#include <memory>

class ClassicSprite;

class ClassicSelection : public kku::Sprite
{
public:

    struct Init
    {
        std::shared_ptr<kku::Rectangle> shape;
        kku::Color color;
    };

    explicit ClassicSelection(ClassicSelection::Init&& init);
    virtual void reset() override;
    virtual void display() const override;

    void adjustTo(const std::shared_ptr<ClassicSprite>& sprite);

protected:
    kku::Color _fill_color;
    std::shared_ptr<kku::Rectangle> _shape;
};
